// This file was automatically generated. Do not edit this file!
#ifndef INITIALIZER_EXOTICA_CORE_TASK_MAPS_JOINT_VELOCITY_LIMIT_CONSTRAINT_INITIALIZER_H
#define INITIALIZER_EXOTICA_CORE_TASK_MAPS_JOINT_VELOCITY_LIMIT_CONSTRAINT_INITIALIZER_H

#include <exotica_core/property.h>

namespace exotica
{
inline std::vector<Initializer> GetExoticaCoreTaskMapsInitializers();
}

namespace exotica
{

class JointVelocityLimitConstraintInitializer : public InitializerBase
{
public:
    static std::string GetContainerName() { return "exotica/JointVelocityLimitConstraint"; }

    JointVelocityLimitConstraintInitializer() : InitializerBase(),
        Debug( false) ,
        EndEffector( std::vector<exotica::Initializer>()) ,
        SafePercentage( 0.0) 
    {
    }

    JointVelocityLimitConstraintInitializer( std::string _Name, Eigen::VectorXd _MaximumJointVelocity, Eigen::VectorXd _StartState, double _dt, bool _Debug =  false, std::vector<exotica::Initializer> _EndEffector =  std::vector<exotica::Initializer>(), double _SafePercentage =  0.0) : InitializerBase(),
        Name(_Name) ,
        MaximumJointVelocity(_MaximumJointVelocity) ,
        StartState(_StartState) ,
        dt(_dt) ,
        Debug(_Debug) ,
        EndEffector(_EndEffector) ,
        SafePercentage(_SafePercentage) 
    {
    }

    JointVelocityLimitConstraintInitializer(const Initializer& other) : JointVelocityLimitConstraintInitializer()
    {
        if (other.HasProperty("Name")) { const Property& prop = other.properties_.at("Name"); if(prop.IsSet()) {Name = boost::any_cast<std::string>(prop.Get());} }
        if (other.HasProperty("MaximumJointVelocity")) { const Property& prop = other.properties_.at("MaximumJointVelocity"); if(prop.IsSet()) {MaximumJointVelocity = prop.IsStringType()?ParseVector<double,Eigen::Dynamic>(boost::any_cast<std::string>(prop.Get())):boost::any_cast<Eigen::VectorXd>(prop.Get());} }
        if (other.HasProperty("StartState")) { const Property& prop = other.properties_.at("StartState"); if(prop.IsSet()) {StartState = prop.IsStringType()?ParseVector<double,Eigen::Dynamic>(boost::any_cast<std::string>(prop.Get())):boost::any_cast<Eigen::VectorXd>(prop.Get());} }
        if (other.HasProperty("dt")) { const Property& prop = other.properties_.at("dt"); if(prop.IsSet()) {dt = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
        if (other.HasProperty("Debug")) { const Property& prop = other.properties_.at("Debug"); if(prop.IsSet()) {Debug = prop.IsStringType()?ParseBool(boost::any_cast<std::string>(prop.Get())):boost::any_cast<bool>(prop.Get());} }
        if (other.HasProperty("EndEffector")) { const Property& prop = other.properties_.at("EndEffector"); if(prop.IsSet()) {EndEffector = boost::any_cast<std::vector<exotica::Initializer>>(prop.Get());} }
        if (other.HasProperty("SafePercentage")) { const Property& prop = other.properties_.at("SafePercentage"); if(prop.IsSet()) {SafePercentage = prop.IsStringType()?ParseDouble(boost::any_cast<std::string>(prop.Get())):boost::any_cast<double>(prop.Get());} }
    }

    virtual ~JointVelocityLimitConstraintInitializer()
    {
    }

    virtual Initializer GetTemplate() const
    {
        return (Initializer)JointVelocityLimitConstraintInitializer();
    }

    virtual std::vector<Initializer> GetAllTemplates() const
    {
        return GetExoticaCoreTaskMapsInitializers();
    }

    virtual void Check(const Initializer& other) const
    {
        if(!other.HasProperty("Name") || !other.properties_.at("Name").IsSet()) ThrowPretty("Initializer JointVelocityLimitConstraintInitializer requires property Name to be set!");
        if(!other.HasProperty("MaximumJointVelocity") || !other.properties_.at("MaximumJointVelocity").IsSet()) ThrowPretty("Initializer JointVelocityLimitConstraintInitializer requires property MaximumJointVelocity to be set!");
        if(!other.HasProperty("StartState") || !other.properties_.at("StartState").IsSet()) ThrowPretty("Initializer JointVelocityLimitConstraintInitializer requires property StartState to be set!");
        if(!other.HasProperty("dt") || !other.properties_.at("dt").IsSet()) ThrowPretty("Initializer JointVelocityLimitConstraintInitializer requires property dt to be set!");
    }

    operator Initializer()
    {
        Initializer ret(GetContainerName());
        ret.properties_.emplace("Name", Property("Name", true, boost::any(Name)));
        ret.properties_.emplace("MaximumJointVelocity", Property("MaximumJointVelocity", true, boost::any(MaximumJointVelocity)));
        ret.properties_.emplace("StartState", Property("StartState", true, boost::any(StartState)));
        ret.properties_.emplace("dt", Property("dt", true, boost::any(dt)));
        ret.properties_.emplace("Debug", Property("Debug", false, boost::any(Debug)));
        ret.properties_.emplace("EndEffector", Property("EndEffector", false, boost::any(EndEffector)));
        ret.properties_.emplace("SafePercentage", Property("SafePercentage", false, boost::any(SafePercentage)));
        return ret;
    }

    std::string Name;
    Eigen::VectorXd MaximumJointVelocity;
    Eigen::VectorXd StartState;
    double dt;
    bool Debug;
    std::vector<exotica::Initializer> EndEffector;
    double SafePercentage;
};

}

#include <exotica_core_task_maps/exotica_core_task_maps_initializers_numerator.h>

#include <exotica_core/frame_initializer.h>

#endif